var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { OverrideUnsetKeyException } from "./exceptions";
var ObjectBuilder = (function () {
    function ObjectBuilder(handlers) {
        this.handlers = handlers;
    }
    ObjectBuilder.create = function () {
        return new ObjectBuilder(new Map());
    };
    ObjectBuilder.prototype.build = function () {
        return Array.from(this.handlers.entries()).reduce(function (self, _a) {
            var key = _a[0], handler = _a[1];
            return Object.defineProperty(self, key, {
                get: function () { return handler(self); },
            });
        }, {});
    };
    ObjectBuilder.prototype.keys = function () {
        return Array.from(this.handlers.keys());
    };
    ObjectBuilder.prototype.with = function (key, handler) {
        return new ObjectBuilder(new Map(__spreadArray(__spreadArray([], Array.from(this.handlers.entries()), true), [[key, handler]], false)));
    };
    ObjectBuilder.prototype.override = function (key, handler) {
        var previous = this.handlers.get(key);
        if (!previous) {
            throw new OverrideUnsetKeyException(key);
        }
        return this.with(key, function (self) { return handler(self, previous(self)); });
    };
    return ObjectBuilder;
}());
export { ObjectBuilder };
//# sourceMappingURL=object-builder.js.map